import { AfterViewInit, Component, ViewChild } from '@angular/core';
import { UsersService } from '../services/users.service';
import { Image, ImagesService } from '../services/images.service';
import { environment } from 'src/environments/environment';
import { ImagesComponent } from '../images/images.component';
import { ScrollService } from '../services/scroll.service';

@Component({
  selector: 'app-page-home',
  templateUrl: './page-home.component.html',
  styleUrls: ['./page-home.component.scss']
})
export class PageHomeComponent implements AfterViewInit {
    @ViewChild("imgs")
    public imagesEl!: ImagesComponent;

    public feed(n: number, i: number) {
        return this.images.feed({ n, i });
    }

    public ngAfterViewInit(): void {
        ImagesComponent.fromFeed(this.scroll.scrollHost!, 10, this.feed.bind(this)).subscribe(v => this.imagesEl.images = v);
    }

    public constructor(
        public users: UsersService,
        public images: ImagesService,
        public scroll: ScrollService,
    ) {
    }
}
